-module(glychee@benchmark).
-compile(no_auto_import).

-export([run/2]).
-export_type([function_/2, data/1]).

-type function_(I, J) :: {function, binary(), fun((I) -> fun(() -> J))}.

-type data(K) :: {data, binary(), K}.

-spec run(list(function_(L, any())), list(data(L))) -> nil.
run(Functions, Datas) ->
    gleam_stdlib_each(
        Datas,
        fun(Data) ->
            io:put_chars(<<"\n\n"/utf8>>),
            io:put_chars(
                <<"================================================================================"/utf8,
                  "\n"/utf8>>
            ),
            io:put_chars(
                <<<<"== data set: "/utf8, (erlang:element(2, Data))/binary>>/binary,
                  " "/utf8>>
            ),
            io:put_chars(<<"\n"/utf8>>),
            io:put_chars(
                <<"================================================================================"/utf8,
                  "\n"/utf8>>
            ),
            io:put_chars(<<"\n"/utf8>>),
            _pipe = Functions,
            _pipe@1 = lists:map(
                fun(Function) ->
                    {function, Function_label, Callable} = Function,
                    {Function_label, Callable(erlang:element(3, Data))}
                end,
                _pipe
            ),
            'Elixir.GlycheeBenchee':run(_pipe@1)
        end
    ).

-spec gleam_stdlib_each(list(S), fun((S) -> any())) -> nil.
gleam_stdlib_each(List, F) ->
    case List of
        [] ->
            nil;

        [X | Xs] ->
            F(X),
            gleam_stdlib_each(Xs, F)
    end.
